diff --git a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java
new file mode 100644
index 000000000..1819a8502
--- /dev/null
+++ b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderViewer.java
@@ -0,0 +1,77 @@
+package net.minecraft.client.world.chunk.provider;
+
+import net.minecraft.core.world.ProgressListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.DisplayChunk;
+import net.minecraft.core.world.chunk.EmptyChunk;
+import net.minecraft.core.world.chunk.provider.IChunkProvider;
+
+public class ChunkProviderViewer implements IChunkProvider {
+    public final Chunk blankChunk;
+    public final Chunk displayChunk;
+    public ChunkProviderViewer(World world){
+        blankChunk = new EmptyChunk(world, 0, 0);
+        displayChunk = new DisplayChunk(world, 0, 0);
+    }
+    @Override
+    public boolean isChunkLoaded(int chunkX, int chunkZ) {
+        return true;
+    }
+
+    @Override
+    public Chunk provideChunk(int chunkX, int chunkZ) {
+        if (chunkX == 0 && chunkZ == 0){
+            return displayChunk;
+        }
+        return blankChunk;
+    }
+
+    @Override
+    public Chunk prepareChunk(int chunkX, int chunkZ) {
+        if (chunkX == 0 && chunkZ == 0){
+            return displayChunk;
+        }
+        return blankChunk;
+    }
+
+    @Override
+    public void regenerateChunk(int chunkX, int chunkZ) {
+
+    }
+
+    @Override
+    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ) {
+
+    }
+
+    @Override
+    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate) {
+        return false;
+    }
+
+    @Override
+    public boolean tick() {
+        return false;
+    }
+
+    @Override
+    public boolean canSave() {
+        return false;
+    }
+
+    @Override
+    public String getInfoString() {
+        return null;
+    }
+
+    @Override
+    public void unloadAllChunks() {
+
+    }
+
+    @Override
+    public void setCurrentChunkOver(int chunkX, int chunkZ) {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 094edce19..c2bbff2fe 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -199,10 +199,20 @@ public class Block
         this.maxZ = maxZ;
     }
 
-    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z)
-    {
-        return blockAccess.getBrightness(x, y, z, lightEmission[id]);
-    }
+	public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z) {
+		return blockAccess.getBrightness(x, y, z, lightEmission[id]);
+	}
+
+	public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
+		return blockAccess.getLightmapCoord(x, y, z, lightEmission[id]);
+	}
+	
+	/**
+	 * Used when fullbright or lightmap is active 
+	 */
+	public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
+		return isSolidRender() ? 1.0f : 0.0f;
+	}
 
     public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
     {
@@ -818,7 +828,7 @@ public class Block
     public static final Block wool = new BlockWool("wool", 110).withHardness(0.8F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_SHEARS);
     public static final Block rope = new BlockRope("rope", 111).withHardness(0.0F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
-            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS);
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS, BlockTags.CAN_HANG_OFF);
 
     public static final Block brickClay = new Block("brick.clay", 120, Material.stone).withHardness(3.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -1230,9 +1240,9 @@ public class Block
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block mesh = new BlockMesh("mesh", 600).withHardness(1.5F)
-            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CAN_HANG_OFF);
     public static final Block meshGold = new BlockMeshGold("mesh.gold", 601).withHardness(1F)
-            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CAN_HANG_OFF);
     
     public static final Block bed = new BlockBed("bed", 610).withHardness(0.2F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
@@ -1350,6 +1360,8 @@ public class Block
 
     public static final Block cake = new BlockCake("cake", 840).withHardness(0.5F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block pumpkinPie = new BlockPumpkinPie("pumpkin_pie", 841).withHardness(0.5F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU);
 
     public static final Block lampIdle = new BlockLamp("lamp.idle", 850, false).withHardness(0.5F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -1416,7 +1428,10 @@ public class Block
     	((BlockLanternFirefly)lanternFireflyBlue).setItem(Item.lanternFireflyBlue);
         ((BlockLanternFirefly)lanternFireflyRed).setItem(Item.lanternFireflyRed);
         ((BlockJar)jarGlass).setItem(Item.jar);
-    	
+
+        ((BlockEdible)cake).setItem(Item.foodCake);
+        ((BlockEdible)pumpkinPie).setItem(Item.foodPumpkinPie);
+
         BlockMoss.initMossMap();
 
         ((BlockLayerBase)layerSnow).setFullBlockID(Block.blockSnow.id);
diff --git a/src/main/java/net/minecraft/core/block/BlockCake.java b/src/main/java/net/minecraft/core/block/BlockCake.java
index 70938f019..672778d78 100644
--- a/src/main/java/net/minecraft/core/block/BlockCake.java
+++ b/src/main/java/net/minecraft/core/block/BlockCake.java
@@ -1,37 +1,14 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, IBlockAccess, World, 
-//            AxisAlignedBB, EntityPlayer
-
-public class BlockCake extends Block
+public class BlockCake extends BlockEdible
 {
 
 	public BlockCake(String key, int id)
     {
-        super(key, id, Material.cake);
-        setTicking(true);
-    }
-
-    @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
-    {
-        if (dropCause == EnumDropCause.PICK_BLOCK || meta == 0)
-        {
-            return new ItemStack[]{new ItemStack(Item.foodCake)};
-        }
-
-        return null;
+        super(key, id, 6, 3);
     }
 
     @Override
@@ -64,72 +41,4 @@ public class BlockCake extends Block
         return AABB.getBoundingBoxFromPool((float) x + f1, y, (float) z + f, (float)(x + 1) - f, (float) y + f2, (float)(z + 1) - f);
     }
 
-    @Override
-	public boolean renderAsNormalBlock()
-    {
-        return false;
-    }
-
-    @Override
-	public boolean isSolidRender()
-    {
-        return false;
-    }
-
-    @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
-    {
-        eatCakeSlice(world, x, y, z, player);
-        return true;
-    }
-
-    @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
-    {
-        eatCakeSlice(world, x, y, z, player);
-    }
-
-    private void eatCakeSlice(World world, int i, int j, int k, EntityPlayer entityplayer)
-    {
-        if(entityplayer.getHealth() < entityplayer.getMaxHealth())
-        {
-            entityplayer.heal(3);
-            int l = world.getBlockMetadata(i, j, k) + 1;
-            if(l >= 6)
-            {
-                world.setBlockWithNotify(i, j, k, 0);
-            } else
-            {
-                world.setBlockMetadataWithNotify(i, j, k, l);
-                world.markBlockDirty(i, j, k);
-            }
-        }
-    }
-
-    @Override
-	public boolean canPlaceBlockAt(World world, int x, int y, int z)
-    {
-        if(!super.canPlaceBlockAt(world, x, y, z))
-        {
-            return false;
-        } else
-        {
-            return canBlockStay(world, x, y, z);
-        }
-    }
-
-    @Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
-    {
-        if(!canBlockStay(world, x, y, z))
-        {
-            world.setBlockWithNotify(x, y, z, 0);
-        }
-    }
-
-    @Override
-    public boolean canBlockStay(World world, int x, int y, int z)
-    {
-        return world.getBlockMaterial(x, y - 1, z).isSolid();
-    }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockChestLegacy.java b/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
index 7a2c8e86f..f647566d7 100644
--- a/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
+++ b/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
@@ -25,7 +25,7 @@ public class BlockChestLegacy extends BlockTileEntity {
 		}
 		Block block = world.getBlock(x, y, z);
 		if(block != null) {
-			return block.getBreakResult(world, dropCause, x, y, z, meta, tileEntity);
+			return super.getBreakResult(world, dropCause, x, y, z, meta, tileEntity);
 		}
 		return null;
 	}
diff --git a/src/main/java/net/minecraft/core/block/BlockEdible.java b/src/main/java/net/minecraft/core/block/BlockEdible.java
new file mode 100644
index 000000000..fde544c91
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockEdible.java
@@ -0,0 +1,109 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public abstract class BlockEdible extends Block {
+
+    public BlockEdible(String key, int id, int maxBites, int healAmount)
+    {
+        super(key, id, Material.cake);
+        this.maxBites = maxBites;
+        this.healAmount = healAmount;
+        setTicking(true);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    {
+        if (dropCause == EnumDropCause.PICK_BLOCK || meta == 0)
+        {
+            return new ItemStack[]{new ItemStack(item)};
+        }
+
+        return null;
+    }
+
+    @Override
+    public boolean renderAsNormalBlock()
+    {
+        return false;
+    }
+
+    @Override
+    public boolean isSolidRender()
+    {
+        return false;
+    }
+
+    private void eatSlice(World world, int x, int y, int z, EntityPlayer entityplayer)
+    {
+        if(entityplayer.getHealth() < entityplayer.getMaxHealth())
+        {
+            entityplayer.heal(healAmount);
+            int data = world.getBlockMetadata(x, y, z) + 1;
+            if(data >= maxBites)
+            {
+                world.setBlockWithNotify(x, y, z, 0);
+            } else
+            {
+                world.setBlockMetadataWithNotify(x, y, z, data);
+                world.markBlockDirty(x, y, z);
+            }
+        }
+    }
+
+    @Override
+    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    {
+        eatSlice(world, x, y, z, player);
+        return true;
+    }
+
+    @Override
+    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    {
+        eatSlice(world, x, y, z, player);
+    }
+
+    @Override
+    public boolean canPlaceBlockAt(World world, int x, int y, int z)
+    {
+        if(!super.canPlaceBlockAt(world, x, y, z))
+        {
+            return false;
+        } else
+        {
+            return canBlockStay(world, x, y, z);
+        }
+    }
+
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
+    {
+        if(!canBlockStay(world, x, y, z))
+        {
+            world.setBlockWithNotify(x, y, z, 0);
+        }
+    }
+
+    @Override
+    public boolean canBlockStay(World world, int x, int y, int z)
+    {
+        return world.getBlockMaterial(x, y - 1, z).isSolid();
+    }
+
+    public void setItem(Item item) {
+        this.item = item;
+    }
+
+    public Item item;
+    public int maxBites;
+    public int healAmount;
+
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java b/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
index ab68601f5..dc177788e 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
@@ -1,17 +1,16 @@
 package net.minecraft.core.block;
 
-import net.minecraft.client.entity.fx.EntityLeafFX;
+import java.util.Random;
+
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.season.Season;
 
-import java.util.Random;
-
 // Referenced classes of package net.minecraft.src:
 //            Block, IBlockAccess, Material
 
@@ -186,6 +185,11 @@ public abstract class BlockLeavesBase extends Block
     public static boolean isPermanent(int meta) {
     	return (meta & 0b1) > 0;
     }
+    
+    @Override
+    public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
+    	return 1.0f;
+    }
 
     int[] adjacentTreeBlocks;
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockPumpkinPie.java b/src/main/java/net/minecraft/core/block/BlockPumpkinPie.java
new file mode 100644
index 000000000..61813f766
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockPumpkinPie.java
@@ -0,0 +1,51 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+
+import java.util.Random;
+
+public class BlockPumpkinPie extends BlockEdible
+{
+
+    public BlockPumpkinPie(String key, int id)
+    {
+        super(key, id, 4, 5);
+    }
+
+    @Override
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    {
+        int l = world.getBlockMetadata(x, y, z);
+        float f = 0.0625F;
+        float xMin = l >= 2 ? 0.5f : f;
+        float zMin = l >= 3 ? 0.5f : f;
+        float f2 = 0.4375F;
+        setBlockBounds(xMin, 0.0F, zMin, 1.0F - f, f2, 1.0F - f);
+    }
+
+    @Override
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    {
+        int l = world.getBlockMetadata(x, y, z);
+        float f = 0.0625F;
+        float xMin = l >= 2 ? 0.5f : f;
+        float zMin = l >= 3 ? 0.5f : f;
+        float f2 = 0.4375F;
+        return AABB.getBoundingBoxFromPool((float) x + xMin, y, (float) z + zMin, (float)(x + 1) - f, ((float) y + f2) - f, (float)(z + 1) - f);
+    }
+
+    @Override
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    {
+        int l = world.getBlockMetadata(x, y, z);
+        float f = 0.0625F;
+        float xMin = l >= 2 ? 0.5f : f;
+        float zMin = l >= 3 ? 0.5f : f;
+        float f2 = 0.4375F;
+        return AABB.getBoundingBoxFromPool((float) x + xMin, y, (float) z + zMin, (float)(x + 1) - f, ((float) y + f2) - f, (float)(z + 1) - f);
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockRope.java b/src/main/java/net/minecraft/core/block/BlockRope.java
index 4867ec371..e55537a66 100644
--- a/src/main/java/net/minecraft/core/block/BlockRope.java
+++ b/src/main/java/net/minecraft/core/block/BlockRope.java
@@ -1,10 +1,13 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityNote;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.ItemToolShears;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -61,6 +64,22 @@ public class BlockRope
 
         setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ);
     }
+    @Override
+    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    {
+        ItemStack heldItem = player.getHeldItem();
+        if (heldItem != null && heldItem.getItem() instanceof ItemToolShears){
+            int meta = world.getBlockMetadata(x, y, z);
+            int forceRope = (~meta) & 0b1000_0000;
+            world.setBlockMetadataWithNotify(x, y, z, forceRope | (meta & 0b0111_1111));
+            heldItem.damageItem(1, player);
+            if (heldItem.stackSize <= 0){
+                player.destroyCurrentEquippedItem();
+            }
+            return true;
+        }
+        return false;
+    }
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
diff --git a/src/main/java/net/minecraft/core/block/BlockTorch.java b/src/main/java/net/minecraft/core/block/BlockTorch.java
index 089334c83..00b469fb5 100644
--- a/src/main/java/net/minecraft/core/block/BlockTorch.java
+++ b/src/main/java/net/minecraft/core/block/BlockTorch.java
@@ -244,4 +244,9 @@ public class BlockTorch extends Block
             world.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
         }
     }
+    
+    @Override
+    public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
+		return blockAccess.getLightmapCoord(x, y, z, lightEmission[id] > 0 ? 15 : 0);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/entity/ConsumedFood.java b/src/main/java/net/minecraft/core/entity/ConsumedFood.java
index 920164a73..b3777b165 100644
--- a/src/main/java/net/minecraft/core/entity/ConsumedFood.java
+++ b/src/main/java/net/minecraft/core/entity/ConsumedFood.java
@@ -19,6 +19,10 @@ public class ConsumedFood {
         healRemaining += food.getHealAmount();
     }
 
+    public int getHealRemaining(){
+        return this.healRemaining;
+    }
+
     public boolean isFinished() {
         return healRemaining <= 0;
     }
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index ed5ff671b..3e6853b5e 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -8,6 +8,7 @@ import com.mojang.nbt.DoubleTag;
 import com.mojang.nbt.FloatTag;
 import com.mojang.nbt.ListTag;
 
+import net.minecraft.client.gui.guidebook.mobs.MobInfoRegistry;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFluid;
@@ -16,6 +17,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
@@ -1453,4 +1455,19 @@ public abstract class Entity
     public float getXRotDelta() {
         return xRot - xRotO;
     }
+
+    public static String getNameFromEntity(Entity entity, boolean useNickname){
+        I18n translator = I18n.getInstance();
+        if (entity instanceof EntityLiving && useNickname){
+            if (!((EntityLiving) entity).nickname.isEmpty()){
+                return ((EntityLiving) entity).nickname;
+            }
+        }
+        if (MobInfoRegistry.getMobInfo(entity.getClass()) != null){
+            return translator.translateKey(MobInfoRegistry.getMobInfo(entity.getClass()).getNameTranslationKey());
+        }
+        String dispatcherName = EntityDispatcher.getEntityString(entity);
+        if (dispatcherName != null) return dispatcherName;
+        return entity.getClass().getSimpleName();
+    }
 }
diff --git a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index a430c79f1..a8044bf50 100644
--- a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -49,6 +49,7 @@ public class EntityDispatcher
         catch(Exception exception)
         {
             exception.printStackTrace();
+            System.out.println("Error with id '" + s + "'");
         }
         return entity;
     }
diff --git a/src/main/java/net/minecraft/core/entity/EntityLiving.java b/src/main/java/net/minecraft/core/entity/EntityLiving.java
index b15c41f72..65ab75554 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLiving.java
+++ b/src/main/java/net/minecraft/core/entity/EntityLiving.java
@@ -148,12 +148,10 @@ public abstract class EntityLiving extends Entity
         ItemStack item = entityplayer.inventory.getCurrentItem();
         if (item != null && item.itemID == Item.label.id && item.hasCustomName())
         {
-            nickname = StringUtils.substring(item.getCustomName(), 0, 32);
             if(item.hasCustomColor()) {
             	this.chatColor = item.getCustomColor();
             }
-            hadNicknameSet = true;
-            onLabelled();
+            setNickname(StringUtils.substring(item.getCustomName(), 0, 32));
             return false;
         }
 
@@ -163,6 +161,11 @@ public abstract class EntityLiving extends Entity
     protected void onLabelled()
     {
     }
+    public void setNickname(String nickname){
+        this.nickname = nickname;
+        hadNicknameSet = true;
+        onLabelled();
+    }
 
     public void playLivingSound()
     {
@@ -232,12 +235,16 @@ public abstract class EntityLiving extends Entity
 
             }
         }
+        List<ItemFood> finishedFood = new ArrayList<>();
         for (Map.Entry<ItemFood, ConsumedFood> entry : consumedFood.entrySet()) {
             entry.getValue().tick();
             if (entry.getValue().isFinished()) {
-                consumedFood.remove(entry.getKey());
+                finishedFood.add(entry.getKey());
             }
         }
+        for (ItemFood food : finishedFood) {
+            consumedFood.remove(food);
+        }
         prevRotationUnused = unusedRotation1;
         prevRenderYawOffset = renderYawOffset;
         yRotO = yRot;
@@ -391,6 +398,15 @@ public abstract class EntityLiving extends Entity
         return 10;
     }
 
+    public int getTotalHealingRemaining(){
+        int totalHealingRemaining = 0;
+        for (ConsumedFood value :
+             consumedFood.values()) {
+            totalHealingRemaining += value.getHealRemaining();
+        }
+        return totalHealingRemaining;
+    }
+
     public void eatFood(ItemFood food) {
         if (food == null) return;
         if (food.getTicksPerHeal() == 0) {
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
index e8b1e4ea4..662a5ad6a 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
@@ -882,7 +882,7 @@ public class EntityWolf extends EntityAnimal
     private float timeWolfIsShaking;
     private float prevTimeWolfIsShaking;
     private ItemStack armor = null;
-    private static final Map<ArmorMaterial, ItemArmor> ARMOR_MATERIALS = new HashMap<>();
+    public static final Map<ArmorMaterial, ItemArmor> ARMOR_MATERIALS = new HashMap<>();
     static {
         ARMOR_MATERIALS.put(ArmorMaterial.LEATHER, (ItemArmor) Item.armorChestplateLeather);
         ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (ItemArmor) Item.armorChestplateChainmail);
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityArmoredZombie.java b/src/main/java/net/minecraft/core/entity/monster/EntityArmoredZombie.java
index dba29fc38..dbc518430 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityArmoredZombie.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityArmoredZombie.java
@@ -19,14 +19,13 @@ import java.util.Random;
 
 public class EntityArmoredZombie extends EntityZombie
 {
-    private final boolean isHoldingSword;
+    private boolean isHoldingSword;
     public EntityArmoredZombie(World world)
     {
         super(world);
         skinName = "zombie_armored";
         Random rand = new Random();
-        isHoldingSword = rand.nextInt(5)==0;
-        attackStrength += isHoldingSword ? 2:0;
+        setHoldingSword(rand.nextInt(5)==0);
         List<Integer> armorItems = new ArrayList<>();
         armorItems.add(0);
         armorItems.add(1);
@@ -109,6 +108,10 @@ public class EntityArmoredZombie extends EntityZombie
         short value = entityData.getShort(7);
         return new int[]{value & 0x3, (value & 0xC) >> 2, (value & 0x30) >> 4, (value & 0xC0) >> 6};
     }
+    public void setHoldingSword(boolean flag){
+        isHoldingSword = flag;
+        attackStrength = isHoldingSword? 7:5;
+    }
 
     @Override
 	public ItemStack getHeldItem()
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java b/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
index 5d7bbb07c..ec36a28fc 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
@@ -108,18 +108,9 @@ public class EntitySnowman extends EntityMonster
     @Override
     protected void dropFewItems()
     {
-        int i = Item.ammoSnowball.id;
-        if(i > 0)
-        {
-            int j = random.nextInt(3);
-            if (random.nextInt(1000) == 0) {
-                id = Item.bucketIcecream.id;
-                j = 1;
-            }
-            for(int k = 0; k < j; k++)
-            {
-                spawnAtLocation(i, 1);
-            }
+        if (random.nextInt(1000) == 0){
+            spawnAtLocation(Item.bucketIcecream.id, 1);
         }
+        super.dropFewItems();
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index f26d8c7d1..1e9991be0 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -425,7 +425,8 @@ public class Item
     public static Item seat = new ItemPlaceable("seat", 16531, Block.seat).setMaxStackSize(64);
     public static Item doorOakPainted = (new ItemDoorPainted("door.oak.painted", 16532, Block.doorPlanksOakPaintedBottom, Block.doorPlanksOakPaintedTop));
     public static Item doorGlass = (new ItemDoor("door.glass", 16533, Block.doorGlassBottom, Block.doorGlassTop));
-    public static Item rope = new ItemPlaceable("rope", 16534, Block.rope);
+    public static Item rope = new ItemRope("rope", 16534, Block.rope);
+    public static Item foodPumpkinPie = (new ItemPlaceable("food.pumpkin_pie", 16535, Block.pumpkinPie)).setMaxStackSize(1);
 
 
     public static int highestItemId = 0;
diff --git a/src/main/java/net/minecraft/core/item/ItemFood.java b/src/main/java/net/minecraft/core/item/ItemFood.java
index 81b46345a..2868deb76 100644
--- a/src/main/java/net/minecraft/core/item/ItemFood.java
+++ b/src/main/java/net/minecraft/core/item/ItemFood.java
@@ -22,7 +22,9 @@ public class ItemFood extends Item
     @Override
     public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
-        if(entityplayer.getHealth() < entityplayer.getMaxHealth() && itemstack.consumeItem(entityplayer)) {
+        if(entityplayer.getHealth() < entityplayer.getMaxHealth()
+                && entityplayer.getHealth() + entityplayer.getTotalHealingRemaining() < entityplayer.getMaxHealth()
+                && itemstack.consumeItem(entityplayer)) {
             entityplayer.eatFood(this);
         }
         return itemstack;
diff --git a/src/main/java/net/minecraft/core/item/ItemRope.java b/src/main/java/net/minecraft/core/item/ItemRope.java
new file mode 100644
index 000000000..14b410cda
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -0,0 +1,50 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class ItemRope extends ItemPlaceable{
+    public ItemRope(String name, int id, Block blockToPlace) {
+        super(name, id, blockToPlace);
+    }
+    @Override
+    public boolean onItemUse(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        if(stack.stackSize <= 0) {
+            return false;
+        }
+        boolean placeOnSide = true;
+        if (world.getBlock(blockX, blockY, blockZ) == blockToPlace && !player.isSneaking()){
+            placeOnSide = false;
+            int _y = blockY;
+            while (_y > 0){
+                _y--;
+                if (world.canBlockBePlacedAt(blockToPlace.id, blockX, _y, blockZ, false, side)){
+                    blockY = _y;
+                    break;
+                } else if (world.getBlock(blockX, _y, blockZ) != blockToPlace) {
+                    break;
+                }
+            }
+
+        }
+        if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
+            blockX += side.getOffsetX();
+            blockY += side.getOffsetY();
+            blockZ += side.getOffsetZ();
+        }
+        if(blockY < 0 || blockY >= world.getHeightBlocks()) {
+            return false;
+        }
+        if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
+            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? 0b1000_0000 : 0)) {
+                blockToPlace.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
+            }
+            return true;
+        }
+        return false;
+    }
+}
